## posixtestsuite 1.5.1

=== Makefile ===
# Copyright (c) 2002, Intel Corporation. All rights reserved.
# Created by:  inaky.perez-gonzalez REMOVE-THIS AT intel DOT com
# This file is licensed under the GPL license.  For the full content
# of this license, see the COPYING file at the top level of this
# source tree.
#
# Kind of a little bit bastardized automakefile ... This is the
# temporary glue to hold it all together; once our needs change or we
# need something more advanced, we'll implement it.
#
# So far, I understand Make is not the best language, but I felt lazy
# today and wanted to use the default rules of automake [did I alredy
# mentioned I am bastardizing it?].
#
# Ok, I don't use Automake any more
#
# Added patch from dank REMOVE-THIS AT kegel DOT com
#

# Added tests timeout from Sebastien Decugis (http://nptl.bullopensource.org) 
# Expiration delay is 120 seconds
TIMEOUT_VAL = 120
# The following value is the shell return value of a timedout application.
# with the bash shell, the ret val of a killed application is 128 + signum
# and under Linux, SIGALRM=14, so we have (Linux+bash) 142.
TIMEOUT_RET = $(shell cat $(top_builddir)/t0.val)

top_builddir = .

LOGFILE = $(top_builddir)/logfile

LDFLAGS := $(shell cat LDFLAGS | grep -v \^\#)

RUN_TESTS := $(shell $(top_builddir)/locate-test \
             --execs $(top_builddir)/$(POSIX_TARGET))
BUILD_TESTS := $(shell $(top_builddir)/locate-test \
               --buildable $(top_builddir)/$(POSIX_TARGET))
FUNCTIONAL_MAKE := $(shell $(top_builddir)/locate-test --fmake)
FUNCTIONAL_RUN := $(shell $(top_builddir)/locate-test --frun)
STRESS_MAKE := $(shell $(top_builddir)/locate-test --smake)
STRESS_RUN := $(shell $(top_builddir)/locate-test --srun)
PWD := $(shell pwd)
TIMEOUT = $(top_builddir)/t0 $(TIMEOUT_VAL)


all: build-tests run-tests 

build-tests: $(BUILD_TESTS:.c=.test)
run-tests: $(RUN_TESTS:.test=.run-test)

functional-tests: functional-make functional-run
stress-tests: stress-make stress-run

tests-pretty:
	$(MAKE) all | column -t -s:

CFLAGS = -g -O2 -Wall -Werror -D_POSIX_C_SOURCE=200112L

# add -std=c99, -std=gnu99 if compiler supports it (gcc-2.95.3 does not).
check_gcc = $(shell if $(CC) $(1) -S -o /dev/null -xc /dev/null > /dev/null 2>&1; then echo "$(1)"; else echo "$(2)"; fi)
CFLAGS += $(call check_gcc,-std=c99,)
CFLAGS += $(call check_gcc,-std=gnu99,)

INCLUDE = -Iinclude

# FIXME: exaust cmd line length
clean:
	@rm -f $(LOGFILE)
# Timeout helper files
	@rm -f $(top_builddir)/t0{,.val}
# Built runnable tests
	@find $(top_builddir) -iname \*.test | xargs -n 40 rm -f {}
	@find $(top_builddir) -iname \*~ -o -iname \*.o | xargs -n 40 rm -f {}
	@$(foreach DIR,$(FUNCTIONAL_MAKE),make -C $(DIR) clean >> /dev/null 2>&1;) >> /dev/null 2>&1

# Rule to run a build test
# If the .o doesn't export main, then we don't need to link
.PRECIOUS: %.test
%.test: %.o
	@COMPLOG=$(LOGFILE).$$$$; \
	[ -f $< ] || exit 0; \
	{ nm -g $< | grep -q " T main"; } || \
	{ echo "$(@:.test=): link: SKIP" | tee -a $(LOGFILE) && exit 0; }; \
	if $(CC) $(CFLAGS) $< -o $@ $(LDFLAGS) > $$COMPLOG 2>&1; \
	then \
		echo "$(@:.test=): link: PASS" | tee -a $(LOGFILE); \
	else \
		( \
			echo "$(@:.test=): link: FAILED. Linker output: "; \
			cat $$COMPLOG; \
		) >> $(LOGFILE); \
		echo "$(@:.test=): link: FAILED "; \
	fi; \
	rm -f $$COMPLOG;

# Rule to run an executable test
# If it is only a build test, then the binary exist, so we don't need to run
.PHONY: %.run-test
%.run-test: %.test $(top_builddir)/t0
	@COMPLOG=$(LOGFILE).$$$$; \
	[ -f $< ] || exit 0; \
	$(TIMEOUT) $< > $$COMPLOG 2>&1; \
	RESULT=$$?; \
	if [ $$RESULT -eq 1 ]; \
	then \
		MSG="FAILED"; \
	fi; \
	if [ $$RESULT -eq 2 ]; \
	then \
		MSG="UNRESOLVED"; \
	fi; \
	if [ $$RESULT -eq 4 ]; \
	then \
		MSG="UNSUPPORTED"; \
	fi; \
	if [ $$RESULT -eq 5 ]; \
	then \
		MSG="UNTESTED"; \
	fi; \
	if [ $$RESULT -eq $(TIMEOUT_RET) ]; \
	then \
		MSG="HUNG"; \
	fi; \
	if [  $$RESULT -gt 5  -a  $$RESULT -ne $(TIMEOUT_RET)  ]; \
	then \
		MSG="INTERRUPTED"; \
	fi; \
	if [ $$RESULT -eq 0 ]; \
	then \
		echo "$(@:.run-test=): execution: PASS" | tee -a $(LOGFILE); \
	else \
		( \
			echo "$(@:.run-test=): execution: $$MSG: Output: "; \
			cat $$COMPLOG; \
		) >> $(LOGFILE); \
		echo "$(@:.run-test=): execution: $$MSG "; \
	fi; \
	rm -f $$COMPLOG;

$(top_builddir)/t0: $(top_builddir)/t0.c
	@echo Building timeout helper files; \
	$(CC) -O2 -o $@ $< ; \
	echo `$(top_builddir)/t0 0; echo $$?` > $(top_builddir)/t0.val
	
%.run-test: %.sh $(top_builddir)/t0
	@COMPLOG=$(LOGFILE).$$$$; \
	chmod +x $<; \
	$(TIMEOUT) $< > $$COMPLOG 2>&1; \
	RESULT=$$?; \
	if [ $$RESULT -eq 0 ]; \
	then \
		echo "$(@:.run-test=): execution: PASS" | tee -a $(LOGFILE);\
	else \
		( \
			echo "$(@:.run-test=): execution: FAILED: Output: ";\
			cat $$COMPLOG; \
		) >> $(LOGFILE); \
		echo "$(@:.run-test=): execution: FAILED "; \
	fi; \
	rm -f $$COMPLOG;


.PRECIOUS: %.o
%.o: %.c
	@COMPLOG=$(LOGFILE).$$$$; \
	if $(CC) $(CFLAGS) $(INCLUDE) -c $< -o $@ $(LDFLAGS) > $$COMPLOG 2>&1; \
	then \
		echo "$(@:.o=): build: PASS" | tee -a $(LOGFILE); \
	else \
		( \
			echo "$(@:.o=): build: FAILED: Compiler output: "; \
			cat $$COMPLOG; \
		) >> $(LOGFILE); \
		echo "$(@:.o=): build: FAILED "; \
	fi; \
	rm -f $$COMPLOG;

# Functional/Stress test build and execution
functional-make:
	$(foreach DIR,$(FUNCTIONAL_MAKE),make -C $(DIR);)

.PHONY: $(FUNCTIONAL_RUN)

functional-run: $(FUNCTIONAL_RUN)

$(FUNCTIONAL_RUN): 
	cd $@; ./run.sh
	cd $(PWD)

stress-make:
	$(foreach DIR,$(STRESS_MAKE),make -C $(DIR);)

.PHONY: $(STRESS_RUN)

stress-run: $(STRESS_RUN)

$(STRESS_RUN): 
	cd $@; ./run.sh
	cd $(PWD)

=== functional/timers/timers/Makefile ===
# Copyright (c) 2002, Intel Corporation. All rights reserved.
# Created by:  julie.n.fleischer REMOVE-THIS AT intel DOT com
# This file is licensed under the GPL license.  For the full content
# of this license, see the COPYING file at the top level of this
# source tree.
#

CFLAGS = -g -O2 -Wall -Werror

INCLUDE = -I../../../include

LDPATH = -L/lib/libposixtime.so

LIB = -lposixtime

all:	twoevtimers.test twoptimers.test

%.test : %.c
	$(CC) $(CFLAGS) $(INCLUDE) $< -o $@ $(LDPATH) $(LIB)

clean :
	rm *.test

## posixtestsuite 1.5.2

=== Makefile ===
--- 
+++ 
@@ -18,8 +18,8 @@
 #
 
 # Added tests timeout from Sebastien Decugis (http://nptl.bullopensource.org) 
-# Expiration delay is 120 seconds
-TIMEOUT_VAL = 120
+# Expiration delay is 240 seconds
+TIMEOUT_VAL = 240
 # The following value is the shell return value of a timedout application.
 # with the bash shell, the ret val of a killed application is 128 + signum
 # and under Linux, SIGALRM=14, so we have (Linux+bash) 142.
@@ -96,7 +96,7 @@
 # Rule to run an executable test
 # If it is only a build test, then the binary exist, so we don't need to run
 .PHONY: %.run-test
-%.run-test: %.test $(top_builddir)/t0
+%.run-test: %.test $(top_builddir)/t0 $(top_builddir)/t0.val
 	@COMPLOG=$(LOGFILE).$$$$; \
 	[ -f $< ] || exit 0; \
 	$(TIMEOUT) $< > $$COMPLOG 2>&1; \
@@ -139,10 +139,12 @@
 
 $(top_builddir)/t0: $(top_builddir)/t0.c
 	@echo Building timeout helper files; \
-	$(CC) -O2 -o $@ $< ; \
+	$(CC) -O2 -o $@ $<
+	
+$(top_builddir)/t0.val: $(top_builddir)/t0
 	echo `$(top_builddir)/t0 0; echo $$?` > $(top_builddir)/t0.val
 	
-%.run-test: %.sh $(top_builddir)/t0
+%.run-test: %.sh $(top_builddir)/t0 $(top_builddir)/t0.val
 	@COMPLOG=$(LOGFILE).$$$$; \
 	chmod +x $<; \
 	$(TIMEOUT) $< > $$COMPLOG 2>&1; \

=== functional/mqueues/Makefile ===
INCLUDE = -I../../include
LIB=-lrt -lpthread

CFLAGS=-Wall -O2 -g

all: send_rev_1.test send_rev_2.test 

%.test : %.c
	$(CC) $(CFLAGS) $(INCLUDE) $< -o $@ $(LIB)   
clean: 
	rm *.test

=== functional/semaphores/Makefile ===

INCLUDE = -I../../include
LIB=

CFLAGS=-Wall -O2 -g 

all:  make-test
make-test: sem_lock.test sem_conpro.test sem_readerwriter.test sem_philosopher.test sem_sleepingbarber.test

%.test : %.c
	$(CC) $(CFLAGS) $(INCLUDE) $< -o $@ $(LIB) -lpthread  
clean: 
	rm *.test

=== stress/semaphores/Makefile ===
ifndef POSIX_DIR_LIB
	POSIX_DIR_LIB=/usr/lib
endif

INCLUDE = -I../../include
LIB=-lposix1b

CC=gcc
CFLAGS=-Wall -O2 -g -I$(POSIX_DIR_INC) -L$(POSIX_DIR_LIB)

all:  multi_con_pro.test

%.test : %.c
	$(CC) $(CFLAGS) $(INCLUDE) $< -o $@ $(LIB) -lpthread  
clean: 
	rm *.test

=== functional/threads/robust_test/Makefile ===
include ../Makefile.inc

SRCS=$(wildcard *.c)
TARGETS=$(patsubst %.c,%,$(SRCS))
CFLAGS+=-Wall -g -I../include

all:$(TARGETS)

clean:
	rm -rf $(TARGETS)

=== functional/threads/schedule/Makefile ===
# Copyright (c) 2004, Intel Corporation. All rights reserved.
# Created by:  adam.li@intel.com
# This file is licensed under the GPL license.  For the full content
# of this license, see the COPYING file at the top level of this
# source tree.

CFLAGS := -Wall -I../../../include -O2
LDFLAGS := -lpthread -lrt

TARGETS := 1-1 1-2 

all: $(TARGETS)

clean:
	rm -f $(TARGETS)

=== functional/timers/clocks/Makefile ===
# Copyright (c) 2002, Intel Corporation. All rights reserved.
# Created by:  julie.n.fleischer REMOVE-THIS AT intel DOT com
# This file is licensed under the GPL license.  For the full content
# of this license, see the COPYING file at the top level of this
# source tree.
#

#CFLAGS = -g -O2 -Wall -Werror
CFLAGS = -g -O2 -Wall -Werror -DDEBUG

INCLUDE = -I../../../include

LDPATH =

LIB = -lrt

all:	twopsetclock.test invaliddates.test

%.test : %.c
	$(CC) $(CFLAGS) $(INCLUDE) $< -o $@ $(LDPATH) $(LIB)

clean :
	rm *.test

=== functional/timers/timers/Makefile ===
--- 
+++ 
@@ -9,9 +9,9 @@
 
 INCLUDE = -I../../../include
 
-LDPATH = -L/lib/libposixtime.so
+LDPATH =
 
-LIB = -lposixtime
+LIB = -lrt
 
 all:	twoevtimers.test twoptimers.test

=== stress/threads/pthread_cond_init/Makefile ===
# Copyright (c) 2004, Intel Corporation. All rights reserved.
# Created by:  adam.li@intel.com
# This file is licensed under the GPL license.  For the full content
# of this license, see the COPYING file at the top level of this
# source tree.

CFLAGS := -Wall -I../../../include -O2
LDFLAGS := -lpthread -lrt

TARGETS := s-c stress

all: $(TARGETS)

clean:
	rm -f $(TARGETS)

=== stress/threads/pthread_cond_timedwait/Makefile ===
# Copyright (c) 2004, Intel Corporation. All rights reserved.
# Created by:  adam.li@intel.com
# This file is licensed under the GPL license.  For the full content
# of this license, see the COPYING file at the top level of this
# source tree.

CFLAGS := -Wall -I../../../include -O2

# If you want date for plotting, uncommnent this flag
# CFLAGS += -DPLOT_OUTPUT

LDFLAGS := -lpthread -lrt -lm

TARGETS := s-c stress1 stress2

all: $(TARGETS)

graph: pthread_cond_timedwait.png

pthread_cond_timedwait.png: s-c.c
	$(CC) $(CFLAGS) -DPLOT_OUTPUT -o s-c s-c.c $(LDFLAGS)
	./s-c > data.plot
	./do-plot data.plot
	rm -f data.plot

clean:
	rm -f $(TARGETS)

=== stress/threads/pthread_create/Makefile ===
# Copyright (c) 2004, Intel Corporation. All rights reserved.
# Created by:  adam.li@intel.com
# This file is licensed under the GPL license.  For the full content
# of this license, see the COPYING file at the top level of this
# source tree.

CFLAGS := -Wall -I../../../include -O2
LDFLAGS := -lpthread -lrt

TARGETS := s-c1 s-c2 stress

all: $(TARGETS)

clean:
	rm -f $(TARGETS)

=== stress/threads/pthread_self/Makefile ===
# Copyright (c) 2004, Intel Corporation. All rights reserved.
# Created by:  adam.li@intel.com
# This file is licensed under the GPL license.  For the full content
# of this license, see the COPYING file at the top level of this
# source tree.

CFLAGS := -Wall -I../../../include -O2
LDFLAGS := -lpthread -lrt

TARGETS := stress

all: $(TARGETS)

clean:
	rm -f $(TARGETS)

=== debian/changelog ===
posixtestsuite (1.5.2-9) unstable; urgency=medium

  * QA upload.
  * Maintain package in Debian team on Salsa
  * Secure URI in Homepage
  * d/watch: Version=5
  * d/copyright: Add paragraph Files: debian/*
  * d/rules: Short dh
  * Standards-Version: 4.7.3 (routine-update)
  * debhelper-compat 13 (routine-update)
  * Remove Priority field to comply with Debian Policy 4.7.3 (routine-
    update)
  * Fix clean target
    Closes: #1045292

 -- Andreas Tille <tille@debian.org>  Tue, 06 Jan 2026 20:41:55 +0100

posixtestsuite (1.5.2-8) unstable; urgency=medium

  * Orphan package, set maintainer to Debian QA Group.
  * Namespace debhelper fragment files with binary package name.
  * Switch to debhelper compatibility level 11.
  * Mark binary package as Multi-Arch: same.
  * Remove spurious space from package description.
  * Now using Standards-Version 4.3.0 (no changes needed).

 -- Guillem Jover <guillem@debian.org>  Sun, 10 Feb 2019 20:00:32 +0100

posixtestsuite (1.5.2-7) unstable; urgency=medium

  * Line-wrap dependency fields.
  * Remove commented-out debhelper commands.
  * Use dpkg Makefile fragments instead of using dpkg-architecture directly.
  * Now using Standards-Version 4.1.1 (no changes needed).
  * Switch to debian/watch format version 4.
  * Switch sf.net URL in debian/watch file from http to https.
  * Switch to debhelper compatibility level 10.
  * Set Rules-Requires-Root to no.

 -- Guillem Jover <guillem@debian.org>  Sun, 05 Nov 2017 17:11:38 +0100

posixtestsuite (1.5.2-6) unstable; urgency=low

  * Switch debian/copyright to machine-readable format 1.0.
  * Switch Vcs-Browser to a cgit URL.
  * Now using Standards-Version 3.9.8 (no changes needed).
  * Use https for hadrons.org URLs.
  * Add patch metadata for patches missing it.

 -- Guillem Jover <guillem@debian.org>  Tue, 31 May 2016 19:44:20 +0200

posixtestsuite (1.5.2-5) unstable; urgency=low

  * Take over standalone maintainership.
    <https://lists.debian.org/debian-bsd/2013/10/msg00227.html>.
  * Now using Standards-Version 3.9.5 (no changes needed).
  * Remove packaging history from debian/copyright.
  * Do not store the timestamp in the gzip compressed report log file.
  * Switch to debhelper compatibility level 9.

 -- Guillem Jover <guillem@debian.org>  Mon, 03 Mar 2014 05:50:27 +0100

posixtestsuite (1.5.2-4) unstable; urgency=low

  * Switch to debhelper compatibility level 7.
  * Use dh_prep instead of “dh_clean -k”.
  * Switch to source format “3.0 (quilt)”:
    - Remove quilt from Build-Depends.
    - Remove quilt.make include from debian/rules.
    - Remove patch and unpatch targets from debian/rules.
    - Remove now unneeded debian/README.source.
  * Now using Standards-Version 3.9.2 (no changes needed).
  * Use coreutils' timeout instead of expect's timeout, as the latter was
    mangling and causing the output to not be written to the logfile.
  * Fix some test case compilation errors due to -Werror.
  * Switch the binary package to be arch:any and ship the test suite
    report in /usr/share/doc/posixtestsuite/report.GNU-TYPE.log.gz.
    This will make the test suite run on all build daemons, so that
    we can easily see how all architectures conform to the standard.
  * Do not try to build test cases from the quilt state directory.
  * Use a stamp file to not run the test suite twice.

 -- Guillem Jover <guillem@debian.org>  Fri, 03 Jun 2011 09:10:32 +0200

posixtestsuite (1.5.2-3) unstable; urgency=low

  * Add a README.source.
  * Now using Standards-Version 3.8.0.
  * Refresh patches with -pab. (Closes: #485358)
  * Refer to GPL-2 from common-licenses instead of just GPL.

 -- Guillem Jover <guillem@debian.org>  Sun, 22 Jun 2008 06:23:45 +0300

posixtestsuite (1.5.2-2) unstable; urgency=low

  * Do not directly use the QA watch redirector, use the sf.net URL instead.
    (Closes: #453608)
  * List in debian/copyright the actual copyright holders, not the authors.
  * Add status fields to the patches.

 -- Guillem Jover <guillem@debian.org>  Wed, 28 May 2008 00:17:11 +0300

posixtestsuite (1.5.2-1) unstable; urgency=low

  * New upstream release.
    - debian/patches/00_find_warnings.patch: Remove, merged upstream.
    - debian/patches/02_expect.diff: Rename to ...
    - debian/patches/02_timeout.patch: ... this. Make all run.sh scripts
      use the provided timeout script.
  * Fix license statement in debian/copyright:
    - Update FSF's copyright address.
    - Change 'program' to 'package'.
  * Remove shlibs:Depends substvar from the Depends.
  * Switch to quilt:
    - Add new debian/patches/series file.
    - Add Build-Depends on 'quilt (>= 0.40)'.
    - Include quilt.make from debian/rules.
    - Make clean a single colon target and depend on unpatch in debian/rules.
    - Remove now unused debian/patch.mk.
  * Add build-indep and build-arch targets, and build depending on both.
  * Rename install to install-indep, and make it depend on build-indep.
  * Make binary-indep depend only on install-indep.
  * Add Homepage, Vcs-Browser and Vcs-Svn fields in debian/control.
  * Do not ignore make errors on 'debian/rules clean'.
  * Bump Standards-Version to 3.7.3 (no changes needed).
  * Move debhelper and quilt from Build-Depends-Indep to Build-Depends, as
    they are used during clean.

 -- Guillem Jover <guillem@debian.org>  Sat, 02 Feb 2008 22:21:08 +0200

posixtestsuite (1.5.1-1) unstable; urgency=low

  * New upstream release.
    - debian/patches/01_linux-gnu.diff: Rename to ...
    - debian/patches/01_gnu.patch: ... this. Rediff.
    - debian/patches/00_find_warnings.patch: Make find POSIX compliant.
    - Do not leave "sigpause/4.1.test" process running after finishing.
      (Closes: #303365)
  * Upgrade to debhelper compat version 5.
  * Switch from cdbs to debhelper.
  * Bump Standards-Version to 3.7.2 (no changes needed).
  * Reindent debian/copyright.
  * Add a watch file.

 -- Guillem Jover <guillem@debian.org>  Wed, 14 Jun 2006 09:15:32 +0300



=== debian/control ===
Source: posixtestsuite
Section: devel
Maintainer: Debian QA Group <packages@qa.debian.org>
Homepage: https://posixtest.sourceforge.net/
Vcs-Browser: https://salsa.debian.org/debian/posixtestsuite
Vcs-Git: https://salsa.debian.org/debian/posixtestsuite.git
Standards-Version: 4.7.3
Rules-Requires-Root: no
Build-Depends:
 debhelper-compat (= 13),

Package: posixtestsuite
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
Description: POSIX conformance test suite report log
 The POSIX Test Suite is a free (as in speech) test suite with the goal
 of performing conformance, functional, and stress testing of the IEEE
 1003.1-2001 System Interfaces specification in a manner that is agnostic
 to any given implementation.
 .
 This package only provides the test suite results in a log file. If you
 want to run the testsuite, use the source package of the same name (e.g.
 apt-get source posixtestsuite).

=== debian/rules ===
#!/usr/bin/make -f

REPORT := /usr/share/doc/posixtestsuite/report.$(DEB_HOST_GNU_TYPE).log

%:
	dh $@

override_dh_installdocs:
	dh_installdocs
	gzip -nc9 logfile >$(CURDIR)/debian/posixtestsuite/$(REPORT).gz

=== debian/watch ===
Version: 5

Source: https://sf.net/posixtest/
Matching-Pattern: @PACKAGE@-@ANY_VERSION@@ARCHIVE_EXT@
